

YssCompare = CreateFrame("Frame")
local YssCompare = YssCompare
YssCompare:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
function YssCompare:Print(...) ChatFrame1:AddMessage("|cFF33FF99Broker: YssCompare|r: "..string.join(", ", ...)) end
YssCompare:RegisterEvent("ADDON_LOADED")

local broker = LibStub("LibDataBroker-1.1")
local icon = LibStub("LibDBIcon-1.0")
local StatLogic = LibStub("LibStatLogic-1.1")

local Stats = { -- Tier1 Stats pulled from LibStatLogic
		"EMPTY_SOCKET_RED",
		"EMPTY_SOCKET_YELLOW",
		"EMPTY_SOCKET_BLUE",
		"EMPTY_SOCKET_META",

		"IGNORE_ARMOR",
		"MOD_THREAT",
		"STEALTH_LEVEL",
		"MELEE_DMG",
		"RANGED_DMG",
		"MOUNT_SPEED",
		"RUN_SPEED",

		"STR",
		"AGI",
		"STA",
		"INT",
		"SPI",
		"ARMOR",
		"ARMOR_BONUS",

		"FIRE_RES",
		"NATURE_RES",
		"FROST_RES",
		"SHADOW_RES",
		"ARCANE_RES",

		"FISHING",
		"MINING",
		"HERBALISM",
		"SKINNING",

		"BLOCK_VALUE",

		"AP",
		"RANGED_AP",
		"FERAL_AP",
		"AP_UNDEAD",
		"AP_DEMON",

		"HEAL",

		"SPELL_DMG",
		"SPELL_DMG_UNDEAD",
		"SPELL_DMG_DEMON",
		"HOLY_SPELL_DMG",
		"FIRE_SPELL_DMG",
		"NATURE_SPELL_DMG",
		"FROST_SPELL_DMG",
		"SHADOW_SPELL_DMG",
		"ARCANE_SPELL_DMG",

		"SPELLPEN",

		"HEALTH",
		"MANA",
		"HEALTH_REG",
		"MANA_REG",

		"MAX_DAMAGE",
		"DPS",

		"DEFENSE_RATING",
		"DODGE_RATING",
		"PARRY_RATING",
		"BLOCK_RATING",
		"MELEE_HIT_RATING",
		"RANGED_HIT_RATING",
		"SPELL_HIT_RATING",
		"MELEE_HIT_AVOID_RATING",
		"RANGED_HIT_AVOID_RATING",
		"SPELL_HIT_AVOID_RATING",
		"MELEE_CRIT_RATING",
		"RANGED_CRIT_RATING",
		"SPELL_CRIT_RATING",
		"MELEE_CRIT_AVOID_RATING",
		"RANGED_CRIT_AVOID_RATING",
		"SPELL_CRIT_AVOID_RATING",
		"RESILIENCE_RATING",
		"MELEE_HASTE_RATING",
		"RANGED_HASTE_RATING",
		"SPELL_HASTE_RATING",
		"DAGGER_WEAPON_RATING",
		"SWORD_WEAPON_RATING",
		"2H_SWORD_WEAPON_RATING",
		"AXE_WEAPON_RATING",
		"2H_AXE_WEAPON_RATING",
		"MACE_WEAPON_RATING",
		"2H_MACE_WEAPON_RATING",
		"GUN_WEAPON_RATING",
		"CROSSBOW_WEAPON_RATING",
		"BOW_WEAPON_RATING",
		"FERAL_WEAPON_RATING",
		"FIST_WEAPON_RATING",
		"STAFF_WEAPON_RATING",
		"EXPERTISE_RATING",
		"ARMOR_PENETRATION_RATING",
}

local equipLocs = {
	["INVTYPE_AMMO"]           = 0,
	["INVTYPE_GUNPROJECTILE"]  = 0,
	["INVTYPE_BOWPROJECTILE"]  = 0,
	["INVTYPE_HEAD"]           = 1,
	["INVTYPE_NECK"]           = 2,
	["INVTYPE_SHOULDER"]       = 3,
	["INVTYPE_BODY"]           = 4,
	["INVTYPE_CHEST"]          = 5,
	["INVTYPE_ROBE"]           = 5,
	["INVTYPE_WAIST"]          = 6,
	["INVTYPE_LEGS"]           = 7,
	["INVTYPE_FEET"]           = 8,
	["INVTYPE_WRIST"]          = 9,
	["INVTYPE_HAND"]           = 10,
	["INVTYPE_FINGER"]         = {11,12},
	["INVTYPE_TRINKET"]        = {13,14},
	["INVTYPE_CLOAK"]          = 15,
	["INVTYPE_WEAPON"]         = {16,17},
	["INVTYPE_2HWEAPON"]       = {16,17},
	["INVTYPE_WEAPONMAINHAND"] = 16,
	["INVTYPE_WEAPONOFFHAND"]  = 17,
	["INVTYPE_SHIELD"]         = 17,
	["INVTYPE_HOLDABLE"]       = 17,
	["INVTYPE_RANGED"]         = 18,
	["INVTYPE_RANGEDRIGHT"]    = 18,
	["INVTYPE_RELIC"]          = 18,
	["INVTYPE_GUN"]            = 18,
	["INVTYPE_CROSSBOW"]       = 18,
	["INVTYPE_WAND"]           = 18,
	["INVTYPE_THROWN"]         = 18,
	["INVTYPE_TABARD"]         = 19,
}



local origs = {}
local function OnTooltipSetItem(tooltip, ...)
	local name, link = tooltip:GetItem()
	if IsEquippableItem(link) then
		local itempoints = YssCompare:YssComparePoints(link)
		local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(link)
		local r,g,b = YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b
		if type(equipLocs[itemEquipLoc]) == 'table' then
			local comparepoints = {}
			comparepoints[1] = YssCompare:YssComparePoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc][1]))
			comparepoints[2] = YssCompare:YssComparePoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc][2]))
			if comparepoints[1] == 0 and comparepoints[2] == 0 then
				comparepoints[1] = nil
				comparepoints[2] = nil
			elseif comparepoints[2] == 0 then
				comparepoints[2] = nil
			end
			if comparepoints[1] and comparepoints[2] then
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.3g|r(%s/%s)", itempoints, YssCompare:ColorNum(itempoints-comparepoints[1]), YssCompare:ColorNum(itempoints-comparepoints[2])),r,g,b,r,g,b)
			elseif comparepoints[1] or comparepoints[2] then
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.3g|r(%s)", itempoints, YssCompare:ColorNum(itempoints-(comparepoints[1] or comparepoints[2]))),r,g,b,r,g,b)
			else
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.3g|r", itempoints),r,g,b,r,g,b)
			end
			--Spew('loc', itemEquipLoc)--INVTYPE_2HWEAPON
		else
			if GetInventoryItemLink("player", equipLocs[itemEquipLoc]) then
				local comparepoints = itempoints-YssCompare:YssComparePoints(GetInventoryItemLink("player", equipLocs[itemEquipLoc]))
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.3g|r(%s)", itempoints, YssCompare:ColorNum(comparepoints)),r,g,b,r,g,b)
			else
				tooltip:AddDoubleLine('YssCompare:', string.format("|cff8080ff%.3g|r", itempoints),r,g,b,r,g,b)
			end
		end
		--Spew('YssCompareTEST', YssCompareItemSource)
		
		tooltip:Show()
	end
	if origs[tooltip] then return origs[tooltip](tooltip, ...) end
end


for _,tooltip in pairs{GameTooltip, ItemRefTooltip, ShoppingTooltip1, ShoppingTooltip2,AtlasLootTooltip} do
	if tooltip then
		origs[tooltip] = tooltip:GetScript("OnTooltipSetItem")
		tooltip:SetScript("OnTooltipSetItem", OnTooltipSetItem)
	end
end

function YssCompare:ColorNum(num)
	if num > 0 then
		return string.format(GREEN_FONT_COLOR_CODE..'+%.3g|r' , num)
	elseif num < 0 then
		return string.format(RED_FONT_COLOR_CODE..'%.3g|r' , num)
	else
		return string.format(HIGHLIGHT_FONT_COLOR_CODE..'%.3g|r' , num)
	end
end


local YssCompareItem = {}
function YssCompare:YssComparePoints(link)
	if not link then return 0 end
	wipe(YssCompareItem)
	local redID = StatLogic:GetGemID(YssCompare.sets[YssCompare.db.profile.WeightSet].gems.EMPTY_SOCKET_RED)
	local yellowID = StatLogic:GetGemID(YssCompare.sets[YssCompare.db.profile.WeightSet].gems.EMPTY_SOCKET_YELLOW)
	local blueID = StatLogic:GetGemID(YssCompare.sets[YssCompare.db.profile.WeightSet].gems.EMPTY_SOCKET_BLUE)
	local metaID = StatLogic:GetGemID(YssCompare.sets[YssCompare.db.profile.WeightSet].gems.EMPTY_SOCKET_META)
	StatLogic:GetSum(StatLogic:BuildGemmedTooltip(StatLogic:RemoveEnchantGem(link) , redID, yellowID, blueID, metaID), YssCompareItem)
	local Points = 0
	for stat , val in pairs(YssCompareItem) do
		if YssCompare.sets[YssCompare.db.profile.WeightSet].stats[stat] then
			if not YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[stat] or GetCombatRating(StatLogic:GetRatingIdOrStatId(stat)) < YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[stat] then
				Points = Points + (val * YssCompare.sets[YssCompare.db.profile.WeightSet].stats[stat])
			end
		end
	end
	return Points
end

function YssCompare:ADDON_LOADED(event, addon)
	if addon == "YssCompare" then
		
		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil
		if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
	end
end

function YssCompare:PLAYER_LOGIN(event, addon)
	YssCompare_Sets = YssCompare_Sets or {
		["Default"] = {
			["stats"] = {},
			["statcaps"] = {},
			["gems"] = {},
		},
	}
	self.sets = YssCompare_Sets
	
	local defaults = {
		["profile"] = {
			['r'] = 1,
			['g'] = .5,
			['b'] = 0,
			["WeightSet"] = 'Default',
		},
	}
	self.db = LibStub("AceDB-3.0"):New("YssCompare_DB", defaults)
	self.db:RegisterCallback("OnProfileChanged", function() YssCompare:ReloadOptions() end)
	self.db:RegisterCallback("OnProfileCopied", function() YssCompare:ReloadOptions() end)
	self.db:RegisterCallback("OnProfileReset", function() YssCompare:ReloadOptions() end)
	
	--TipHooker:Hook(self.ProcessTooltip, "item")
	self:SetupStatOptions()
	
	--self:CreateBroker()
	--icon:Register("YssCompare", YssCompare.obj, YssCompare.db.profile.LibDBIcon)
	--broker.RegisterCallback(YssCompare, "LibDataBroker_DataObjectCreated")
	self:RegisterModuleOptions('profile', LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), 'Profile')
	self:ReloadOptions()
	self:UnregisterEvent("PLAYER_LOGIN")
	self.PLAYER_LOGIN = nil
end


function YssCompare:ReloadOptions()

end

do

	local ReverseStats = {}
	for i,stat in ipairs(Stats) do
		ReverseStats[stat] = i
	end
	local L_Stats = {} -- Localized stats
	for i,stat in ipairs(Stats) do
		L_Stats[i] = StatLogic:GetStatNameFromID(stat)
	end
	local SelectedStat
	local StatOptionsTable
	local function Getter(info)
		if YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] then
			return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]])
		end
	end
	
	local function Setter(info, val)
		if val == '' then
			YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] = nil
		else
			YssCompare.sets[YssCompare.db.profile.WeightSet].gems[info[#info]] = tonumber(val)
		end
	end
	
	local function Validator(info, val)
		if tonumber(val) or val == '' then
			return true
		else
			return "Input must be a number or and empty input"
		end
	end
	local function Descriptor(info)
		local item = Getter(info)
		if item then
			return select(2,StatLogic:GetGemID(item)).."|nAccepts the gem itemID only"
		end
		return 'Accepts the gem itemID only'
	end
	
	local StatWeight = {
			name = function(info) return StatLogic:GetStatNameFromID(info[#info]) end,
			order = function(info)
				return -1*(YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info]] + 1000)
			end,
			type = "group",
			inline = true,
			args = {
				Weight = {
					name = "Weight:",
					order = 1,
					type = 'input',
					width = 'half',
					validate = function(info, val)
						if tonumber('0'..val) then
							return true
						else
							return "Input must be a number"
						end
					end,
					get = function(info)
						return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]])
					end,
					set = function(info,val)
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]] = tonumber('0'..val)
					end,
				},
				Cap = {
					name = "Stat Cap:",
					order = 2,
					type = 'input',
					width = 'half',
					validate = function(info, val)
						if tonumber('0'..val) or val == '' then
							return true
						else
							return "Input must be a number or and empty input"
						end
					end,
					disabled = function(info)
						return not StatLogic:GetRatingIdOrStatId(info[#info-1])
					end,
					hidden = function(info)
						return not StatLogic:GetRatingIdOrStatId(info[#info-1])
					end,
					get = function(info)
						if YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] then
							return tostring(YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]])
						end
					end,
					set = function(info,val)
						if val == '' then
							YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = nil
						else
							YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = tonumber('0'..val)
						end
					end,
				},
				Remove = {
					name = "Remove",
					order = 3,
					type = 'execute',
					width = 'half',
					func = function(info)
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[info[#info-1]] = nil
						YssCompare.sets[YssCompare.db.profile.WeightSet].statcaps[info[#info-1]] = nil
						StatOptionsTable.StatWeights.args[info[#info-1]] = nil
					end,
				},
			}
	}
	
	function YssCompare:SetupStatOptions()
		StatOptionsTable = {
				EMPTY_SOCKET_RED = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Red Gem: '..gem
					end,
					type = 'input',
					order = 10,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_YELLOW = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Yellow Gem: '..gem
					end,
					type = 'input',
					order = 20,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_BLUE = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Blue Gem: '..gem
					end,
					type = 'input',
					order = 30,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				EMPTY_SOCKET_META = {
					name = function(info)
						local item = Getter(info)
						local _, gem
						if item then
							_, gem = GetItemInfo(item)
						end
						if not gem then gem = '' end
						return 'Meta Gem: '..gem
					end,
					type = 'input',
					order = 40,
					desc = Descriptor,
					validate = Validator,
					get = Getter,
					set = Setter,
				},
				StatsList = {
					name = "Stat:",
					values = L_Stats,
					order = 50,
					type = 'select',
					get = function(info)
						return SelectedStat
					end,
					set = function(info,val)
						SelectedStat = val
					end
				},
				StatAdd = {
					name = "Add",
					order = 60,
					width = 'half',
					type = 'execute',
					disabled = function() return not SelectedStat end,
					func = function()
						YssCompare.sets[YssCompare.db.profile.WeightSet].stats[Stats[SelectedStat]] = 0
						StatOptionsTable.StatWeights.args[Stats[SelectedStat]] = StatWeight
						SelectedStat = nil
					end,
				},
				StatWeights = {
					name = "Stat Weights:",
					type = "group",
					order = 70,
					args = {}
				},
		}
		for stat in pairs(YssCompare.sets[YssCompare.db.profile.WeightSet].stats) do
			StatOptionsTable.StatWeights.args[stat] = StatWeight
		end
		self.MainOption.args.SetSetup.args = StatOptionsTable
	end
end

do
	local WeightSets = {}
	local WeightSets2 = {}
	YssCompare.MainOption = {
		type="group",
		childGroups = 'select',
		handler = YssCompare,
		args = {
			Color = {
				name = "Tooltip Line Color",
				type = 'color',
				order = 1,
				get = function(info)
					return YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b
				end,
				set = function(info,r,g,b)
					YssCompare.db.profile.r, YssCompare.db.profile.g, YssCompare.db.profile.b = r,g,b
				end,
			},
			WeightSet = {
				name = "Current Weight Set:",
				type = 'select',
				order = 100,
				values = function()
					wipe(WeightSets)
					for set in pairs(YssCompare.sets) do
						WeightSets[set] = set
					end
					return WeightSets
				end,
				get = function(info)
					return YssCompare.db.profile.WeightSet
				end,
				set = function(info,val)
					YssCompare.db.profile.WeightSet = val
					YssCompare:SetupStatOptions()
				end,
			},
			NewSet = {
				name = "New Weight Set:",
				order = 110,
				type = 'input',
				set = function(info, val)
					YssCompare.sets[val] = {
						["stats"] = {},
						["statcaps"] = {},
						["gems"] = {},
					}
					YssCompare.db.profile.WeightSet = val
					YssCompare:SetupStatOptions()
				end,
			},
			DeleteSet = {
				name = "Delete Set:",
				order = 120,
				type = 'select',
				values = function()
					wipe(WeightSets2)
					for set in pairs(YssCompare.sets) do
						WeightSets2[set] = set
					end
					WeightSets2['Default'] = nil
					return WeightSets2
				end,
				confirm = true,
				confirmText = 'Are you sure you want to delete the selected set?',
				set = function(info, val)
					YssCompare.sets[val] = nil
					if YssCompare.db.profile.WeightSet == val then
						YssCompare.db.profile.WeightSet = 'Default'
					end
					YssCompare:SetupStatOptions()
				end,
			},
			SetSetup = {
				name = 'Set Setup',
				type = 'group',
				order = 200,
				inline = true,
			},
			
			test = {
				name = 'Test',
				order = -1,
				type = "execute",
				func = function(info)
					YssCompare:Print("Hello World")
					YssCompare:Print(StatLogic:GetGemID('Bold Scarlet Ruby'))
					YssCompare:Print(StatLogic:GetGemID('39996'))
					YssCompare:Print(StatLogic:GetGemID(39996))
					YssCompare:Print(GetItemInfo('Bold Scarlet Ruby'))
					YssCompare:Print(GetItemInfo('39996'))
					YssCompare:Print(GetItemInfo(39996))
				end,
			},
		},
	}
end

YssCompare.optframe = {}
LibStub("AceConfig-3.0"):RegisterOptionsTable('YssCompareConfig', YssCompare.MainOption)
YssCompare.optframe.YssCompare = LibStub("AceConfigDialog-3.0"):AddToBlizOptions('YssCompareConfig', 'YssCompare')
-- function addapted from the RegisterModuleOptions function in Mapster
function YssCompare:RegisterModuleOptions(name, optionTbl, displayName)
	local cname = "YssCompareConfig_"..name
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable(cname, optionTbl)
	self.optframe[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(cname, displayName, "YssCompare")
end

